{
    "$graph": [
        {
            "label": "bacterial_kmer",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/ANI_cutoff"
                },
                {
                    "type": "File",
                    "id": "#main/Extract_Kmers_From_Input___entry"
                },
                {
                    "type": "File",
                    "id": "#main/ani_report_transform"
                },
                {
                    "type": "Directory",
                    "id": "#main/asn_cache"
                },
                {
                    "type": "File",
                    "id": "#main/gc_cache"
                },
                {
                    "type": "Directory",
                    "id": "#main/gc_seq_cache"
                },
                {
                    "type": "File",
                    "id": "#main/gcextract2_sqlite"
                },
                {
                    "type": "File",
                    "id": "#main/gencoll_asn"
                },
                {
                    "type": "File",
                    "id": "#main/kmer_cache_sqlite"
                },
                {
                    "type": "File",
                    "id": "#main/kmer_reference_assemblies"
                },
                {
                    "type": "int",
                    "id": "#main/ref_assembly_id"
                },
                {
                    "type": "int",
                    "id": "#main/ref_assembly_taxid"
                },
                {
                    "type": "File",
                    "id": "#main/tax_synon"
                },
                {
                    "type": "File",
                    "id": "#main/taxon_db"
                }
            ],
            "steps": [
                {
                    "label": "Assembly Assembly BLASTn",
                    "doc": "This is rather standard blast",
                    "run": "#tt_assm_assm_blastn_wnode.cwl",
                    "in": [
                        {
                            "default": "subject",
                            "id": "#main/Assembly_Assembly_BLASTn/affinity"
                        },
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/Assembly_Assembly_BLASTn/asn_cache"
                        },
                        {
                            "default": true,
                            "id": "#main/Assembly_Assembly_BLASTn/compart"
                        },
                        {
                            "default": 0.0001,
                            "id": "#main/Assembly_Assembly_BLASTn/evalue"
                        },
                        {
                            "default": 1,
                            "id": "#main/Assembly_Assembly_BLASTn/gapextend"
                        },
                        {
                            "default": 2,
                            "id": "#main/Assembly_Assembly_BLASTn/gapopen"
                        },
                        {
                            "source": "#main/gc_cache",
                            "id": "#main/Assembly_Assembly_BLASTn/gc_cache"
                        },
                        {
                            "source": "#main/gc_seq_cache",
                            "id": "#main/Assembly_Assembly_BLASTn/gc_seq_cache"
                        },
                        {
                            "source": "#main/gencoll_asn",
                            "id": "#main/Assembly_Assembly_BLASTn/gencoll_asn"
                        },
                        {
                            "default": 500000000,
                            "id": "#main/Assembly_Assembly_BLASTn/max_bases_per_call"
                        },
                        {
                            "default": 250,
                            "id": "#main/Assembly_Assembly_BLASTn/max_target_seqs"
                        },
                        {
                            "default": "((reciprocity = 3 AND align_length_ungap >= 5) OR align_length > 1000) AND pct_identity_gap > 25",
                            "id": "#main/Assembly_Assembly_BLASTn/merge_align_filter"
                        },
                        {
                            "default": "tree-merger",
                            "id": "#main/Assembly_Assembly_BLASTn/merge_engine"
                        },
                        {
                            "source": "#main/Extract_Input_GenColl_IDs/output",
                            "id": "#main/Assembly_Assembly_BLASTn/queries_gc_id_list"
                        },
                        {
                            "source": "#main/Get_Top_Assemblies_GenColl_ASN/gencoll_asn",
                            "id": "#main/Assembly_Assembly_BLASTn/ref_gencoll_asn"
                        },
                        {
                            "default": "true",
                            "id": "#main/Assembly_Assembly_BLASTn/soft_masking"
                        },
                        {
                            "source": "#main/Extract_Top_Assemblies/gc_id_list",
                            "id": "#main/Assembly_Assembly_BLASTn/subjects_gc_id_list"
                        },
                        {
                            "default": "megablast",
                            "id": "#main/Assembly_Assembly_BLASTn/task"
                        },
                        {
                            "default": true,
                            "id": "#main/Assembly_Assembly_BLASTn/use_common_components"
                        },
                        {
                            "default": 150,
                            "id": "#main/Assembly_Assembly_BLASTn/window_size"
                        },
                        {
                            "default": 28,
                            "id": "#main/Assembly_Assembly_BLASTn/word_size"
                        },
                        {
                            "default": 0.4,
                            "id": "#main/Assembly_Assembly_BLASTn/workers_per_cpu"
                        }
                    ],
                    "out": [
                        "#main/Assembly_Assembly_BLASTn/blast_align"
                    ],
                    "id": "#main/Assembly_Assembly_BLASTn"
                },
                {
                    "label": "Build Kmer Tree",
                    "doc": "Output is BioTree ASN.1",
                    "run": "#tt_kmer_build_tree.cwl",
                    "in": [
                        {
                            "source": "#main/Compare_Kmer__Pairwise_/distances",
                            "id": "#main/Build_Kmer_Tree/distances"
                        },
                        {
                            "default": true,
                            "id": "#main/Build_Kmer_Tree/no_merge"
                        },
                        {
                            "default": true,
                            "id": "#main/Build_Kmer_Tree/skip_markup"
                        },
                        {
                            "default": "leaf-count-ascending",
                            "id": "#main/Build_Kmer_Tree/sort"
                        }
                    ],
                    "out": [
                        "#main/Build_Kmer_Tree/tree"
                    ],
                    "id": "#main/Build_Kmer_Tree"
                },
                {
                    "label": "Combine kmer SQLITE",
                    "doc": "This new step will combine together reference kmer store and newly created kmer store for a new assembly\n",
                    "run": "#combine_kmer_sqlite.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/Combine_kmer_sqlite/fast"
                        },
                        {
                            "source": [
                                "#main/kmer_cache_sqlite",
                                "#main/Convert_kmer_files_to_sqlite/out_kmer_cache_sqlite"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/Combine_kmer_sqlite/kmer_cache_sqlite"
                        }
                    ],
                    "out": [
                        "#main/Combine_kmer_sqlite/combined_cache_sqlite"
                    ],
                    "id": "#main/Combine_kmer_sqlite"
                },
                {
                    "label": "Compare Kmer",
                    "doc": "compares kmers from different genomes in the input and produces distance matrix\nfilled only for ref vs current elements\n",
                    "run": "#tt_kmer_ref_compare_wnode.cwl",
                    "in": [
                        {
                            "default": "minhash",
                            "id": "#main/Compare_Kmer/dist_method"
                        },
                        {
                            "source": "#main/Combine_kmer_sqlite/combined_cache_sqlite",
                            "id": "#main/Compare_Kmer/kmer_cache_sqlite"
                        },
                        {
                            "source": "#main/List_sqlite/keys",
                            "id": "#main/Compare_Kmer/kmer_list"
                        },
                        {
                            "default": "minhash",
                            "id": "#main/Compare_Kmer/minhash_signature"
                        },
                        {
                            "source": "#main/kmer_reference_assemblies",
                            "id": "#main/Compare_Kmer/ref_kmer_list"
                        },
                        {
                            "default": "boolean",
                            "id": "#main/Compare_Kmer/score_method"
                        }
                    ],
                    "out": [
                        "#main/Compare_Kmer/distances",
                        "#main/Compare_Kmer/outdir"
                    ],
                    "id": "#main/Compare_Kmer"
                },
                {
                    "label": "Glue SQLITE keys",
                    "run": "#cat.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/List_sqlite/keys",
                                "#main/Identify_Top_N/matches"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/Compare_Kmer_Pairwise_prepare_input/input"
                        },
                        {
                            "default": "target_and_matches.ids",
                            "id": "#main/Compare_Kmer_Pairwise_prepare_input/output_file_name"
                        }
                    ],
                    "out": [
                        "#main/Compare_Kmer_Pairwise_prepare_input/output"
                    ],
                    "id": "#main/Compare_Kmer_Pairwise_prepare_input"
                },
                {
                    "label": "Compare Kmer pairwise",
                    "doc": "compares kmers from top hits to query genome in the input and produces distance matrix for subsequent tree: all-against-all. This is the most downstream node requiring sqlite cache\n",
                    "run": "#tt_kmer_compare_wnode.cwl",
                    "in": [
                        {
                            "default": "minhash",
                            "id": "#main/Compare_Kmer__Pairwise_/dist_method"
                        },
                        {
                            "source": "#main/Combine_kmer_sqlite/combined_cache_sqlite",
                            "id": "#main/Compare_Kmer__Pairwise_/kmer_cache_sqlite"
                        },
                        {
                            "source": "#main/Compare_Kmer_Pairwise_prepare_input/output",
                            "id": "#main/Compare_Kmer__Pairwise_/kmer_list"
                        },
                        {
                            "default": "minhash",
                            "id": "#main/Compare_Kmer__Pairwise_/minhash_signature"
                        },
                        {
                            "default": "boolean",
                            "id": "#main/Compare_Kmer__Pairwise_/score_method"
                        }
                    ],
                    "out": [
                        "#main/Compare_Kmer__Pairwise_/distances"
                    ],
                    "id": "#main/Compare_Kmer__Pairwise_"
                },
                {
                    "label": "Convert Kmer files to SQLITE",
                    "doc": "This new step will convert input .kmer.gz (kmer_file) and .xml (kmer_metadata_file)\ninto new sqlite database\nThe program we are calling here takes a directory input\n",
                    "run": "#kmer_files2sqlite.cwl",
                    "in": [
                        {
                            "source": "#main/Extract_Kmers_From_Input/out_kmer_dir",
                            "id": "#main/Convert_kmer_files_to_sqlite/kmer_dir"
                        }
                    ],
                    "out": [
                        "#main/Convert_kmer_files_to_sqlite/out_kmer_cache_sqlite"
                    ],
                    "id": "#main/Convert_kmer_files_to_sqlite"
                },
                {
                    "run": "#xml_evaluate.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/Evaluate_ANI_report/ignore_all_errors"
                        },
                        {
                            "source": "#main/Identify_Top_N_ANI/top",
                            "id": "#main/Evaluate_ANI_report/input"
                        },
                        {
                            "default": "errors.xml",
                            "id": "#main/Evaluate_ANI_report/stdout_redir"
                        },
                        {
                            "default": "/tax-check/results[@status='MISASSIGNED' or @status='CONTAMINATED']\n",
                            "id": "#main/Evaluate_ANI_report/xpath_fail"
                        }
                    ],
                    "out": [
                        "#main/Evaluate_ANI_report/xml_output"
                    ],
                    "id": "#main/Evaluate_ANI_report"
                },
                {
                    "label": "Extract Input GenColl IDs",
                    "doc": "Input is input ASN.1 file for our target assembly",
                    "run": "#gc_extract_ids.cwl",
                    "in": [
                        {
                            "source": "#main/gencoll_asn",
                            "id": "#main/Extract_Input_GenColl_IDs/input"
                        }
                    ],
                    "out": [
                        "#main/Extract_Input_GenColl_IDs/output"
                    ],
                    "id": "#main/Extract_Input_GenColl_IDs"
                },
                {
                    "label": "Extract Kmers From Input",
                    "run": "#tt_kmer_seq_entry_extract_wnode.cwl",
                    "doc": "computes kmers for input genome (Extract_Kmers_From_Input___entry)\nproduces kmer files (.gz and xml)\nit will have a new output: out_kmer_dir\n",
                    "in": [
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/Extract_Kmers_From_Input/asn_cache"
                        },
                        {
                            "source": "#main/Extract_Kmers_From_Input___entry",
                            "id": "#main/Extract_Kmers_From_Input/entry"
                        },
                        {
                            "source": [
                                "#main/kmer_reference_assemblies"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/Extract_Kmers_From_Input/kmer_file_list"
                        }
                    ],
                    "out": [
                        "#main/Extract_Kmers_From_Input/out_kmer_dir"
                    ],
                    "id": "#main/Extract_Kmers_From_Input"
                },
                {
                    "label": "Extract Top Assemblies",
                    "doc": "Takes XML file with top distances between matches and reference assembly taxid\nproduces XML tax report and list of top matched assemblies \n",
                    "run": "#tt_kmer_top_n_extract.cwl",
                    "in": [
                        {
                            "source": "#main/gcextract2_sqlite",
                            "id": "#main/Extract_Top_Assemblies/gcextract2_sqlite"
                        },
                        {
                            "source": "#main/ref_assembly_id",
                            "id": "#main/Extract_Top_Assemblies/ref_assembly_id"
                        },
                        {
                            "source": "#main/ref_assembly_taxid",
                            "id": "#main/Extract_Top_Assemblies/ref_assembly_taxid"
                        },
                        {
                            "source": "#main/taxon_db",
                            "id": "#main/Extract_Top_Assemblies/taxon_db"
                        },
                        {
                            "source": "#main/Identify_Top_N/top_distances",
                            "id": "#main/Extract_Top_Assemblies/top_distances"
                        }
                    ],
                    "out": [
                        "#main/Extract_Top_Assemblies/tax_report",
                        "#main/Extract_Top_Assemblies/gc_id_list"
                    ],
                    "id": "#main/Extract_Top_Assemblies"
                },
                {
                    "label": "Get Top Assemblies GenColl ASN",
                    "doc": "Input is list of reference assemblies, not to be mixed with list of URIs",
                    "run": "#tt_gcaccess_from_list.cwl",
                    "in": [
                        {
                            "source": "#main/gc_cache",
                            "id": "#main/Get_Top_Assemblies_GenColl_ASN/gc_cache"
                        },
                        {
                            "source": "#main/Extract_Top_Assemblies/gc_id_list",
                            "id": "#main/Get_Top_Assemblies_GenColl_ASN/gc_id_list"
                        }
                    ],
                    "out": [
                        "#main/Get_Top_Assemblies_GenColl_ASN/gencoll_asn"
                    ],
                    "id": "#main/Get_Top_Assemblies_GenColl_ASN"
                },
                {
                    "label": "Identify Top N hits by Kmer",
                    "doc": "Identifies Top N hits to input genome by kmer distances \nproduces distances XML and list of matching genomes (storage URIs)\n",
                    "run": "#tt_kmer_top_n.cwl",
                    "in": [
                        {
                            "source": "#main/Compare_Kmer/distances",
                            "id": "#main/Identify_Top_N/distances"
                        },
                        {
                            "source": "#main/Combine_kmer_sqlite/combined_cache_sqlite",
                            "id": "#main/Identify_Top_N/kmer_cache_sqlite"
                        }
                    ],
                    "out": [
                        "#main/Identify_Top_N/matches",
                        "#main/Identify_Top_N/top_distances"
                    ],
                    "id": "#main/Identify_Top_N"
                },
                {
                    "doc": "identify top N ANI",
                    "label": "Identify Top N ANI",
                    "run": "#tt_ani_top_n.cwl",
                    "in": [
                        {
                            "source": "#main/ANI_cutoff",
                            "id": "#main/Identify_Top_N_ANI/ANI_cutoff"
                        },
                        {
                            "source": [
                                "#main/asn_cache",
                                "#main/gc_seq_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/Identify_Top_N_ANI/asn_cache"
                        },
                        {
                            "source": "#main/Assembly_Assembly_BLASTn/blast_align",
                            "id": "#main/Identify_Top_N_ANI/blast_align"
                        },
                        {
                            "source": "#main/gcextract2_sqlite",
                            "id": "#main/Identify_Top_N_ANI/gcextract2_sqlite"
                        },
                        {
                            "source": "#main/gencoll_asn",
                            "id": "#main/Identify_Top_N_ANI/gencoll_asn"
                        },
                        {
                            "source": "#main/ref_assembly_id",
                            "id": "#main/Identify_Top_N_ANI/ref_assembly_id"
                        },
                        {
                            "source": "#main/ref_assembly_taxid",
                            "id": "#main/Identify_Top_N_ANI/ref_assembly_taxid"
                        },
                        {
                            "source": "#main/Get_Top_Assemblies_GenColl_ASN/gencoll_asn",
                            "id": "#main/Identify_Top_N_ANI/ref_gencoll_asn"
                        },
                        {
                            "source": "#main/tax_synon",
                            "id": "#main/Identify_Top_N_ANI/tax_synon"
                        },
                        {
                            "source": "#main/taxon_db",
                            "id": "#main/Identify_Top_N_ANI/taxon_db"
                        }
                    ],
                    "out": [
                        "#main/Identify_Top_N_ANI/top",
                        "#main/Identify_Top_N_ANI/annot"
                    ],
                    "id": "#main/Identify_Top_N_ANI"
                },
                {
                    "doc": "transform ANI taxcheck report XML file to Genbank suitable (SMART equivalent) text report",
                    "run": "#xsltproc.cwl",
                    "in": [
                        {
                            "default": "ani-tax-report.txt",
                            "id": "#main/Identify_Top_N_ANI_transform/output_name"
                        },
                        {
                            "source": "#main/Identify_Top_N_ANI/top",
                            "id": "#main/Identify_Top_N_ANI_transform/xml"
                        },
                        {
                            "source": "#main/ani_report_transform",
                            "id": "#main/Identify_Top_N_ANI_transform/xslt"
                        }
                    ],
                    "out": [
                        "#main/Identify_Top_N_ANI_transform/output"
                    ],
                    "id": "#main/Identify_Top_N_ANI_transform"
                },
                {
                    "label": "List SQLITE kmer cache contents",
                    "doc": "Produces the list of all keys in sqlite database",
                    "run": "#list_kmer_sqlite.cwl",
                    "in": [
                        {
                            "source": "#main/Convert_kmer_files_to_sqlite/out_kmer_cache_sqlite",
                            "id": "#main/List_sqlite/kmer_cache_sqlite"
                        }
                    ],
                    "out": [
                        "#main/List_sqlite/keys"
                    ],
                    "id": "#main/List_sqlite"
                }
            ],
            "id": "#main",
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/Extract_Top_Assemblies/tax_report",
                    "id": "#main/Extract_Top_Assemblies___tax_report"
                },
                {
                    "type": "File",
                    "outputSource": "#main/Identify_Top_N_ANI/annot",
                    "id": "#main/Identify_Top_N_ANI_annot"
                },
                {
                    "type": "File",
                    "outputSource": "#main/Identify_Top_N_ANI/top",
                    "id": "#main/Identify_Top_N_ANI_top"
                },
                {
                    "type": "File",
                    "outputSource": "#main/Identify_Top_N_ANI_transform/output",
                    "id": "#main/Identify_Top_N_ANI_top_txt"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/Evaluate_ANI_report/xml_output",
                    "id": "#main/errors"
                }
            ]
        },
        {
            "label": "ani_top_identification",
            "class": "CommandLineTool",
            "baseCommand": "ani_top_identification",
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-ANI_cutoff"
                    },
                    "id": "#ani_top_identification.cwl/ANI_cutoff"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-N"
                    },
                    "id": "#ani_top_identification.cwl/N"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#ani_top_identification.cwl/asn_cache"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gcextract2-sqlite"
                    },
                    "id": "#ani_top_identification.cwl/gcextract2_sqlite"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#ani_top_identification.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-min-gap"
                    },
                    "id": "#ani_top_identification.cwl/min_gap"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-min-region"
                    },
                    "id": "#ani_top_identification.cwl/min_region"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "ani-tax-report.xml",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#ani_top_identification.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "annot.asn",
                    "inputBinding": {
                        "prefix": "-o-annot"
                    },
                    "id": "#ani_top_identification.cwl/o_annot"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-query-assembly"
                    },
                    "id": "#ani_top_identification.cwl/query_assembly"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-ref-assemblies"
                    },
                    "id": "#ani_top_identification.cwl/ref_assemblies"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-ref-assembly-id"
                    },
                    "id": "#ani_top_identification.cwl/ref_assembly_id"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-ref-assembly-taxid"
                    },
                    "id": "#ani_top_identification.cwl/ref_assembly_taxid"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-tax-syn-table"
                    },
                    "id": "#ani_top_identification.cwl/tax_synon"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-taxon-db"
                    },
                    "id": "#ani_top_identification.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o_annot)"
                    },
                    "id": "#ani_top_identification.cwl/annot"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    },
                    "id": "#ani_top_identification.cwl/top"
                }
            ],
            "id": "#ani_top_identification.cwl"
        },
        {
            "label": "assm_assm_blastn_create_jobs",
            "class": "CommandLineTool",
            "baseCommand": "assm_assm_blastn_create_jobs",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "q.mft",
                            "entry": "${\n  var blob = '# q.mft created for assm_assm_blastn_create_jobs from input \"queries_gc_id_list\" File\\n'; \n  if(inputs.queries_gc_id_list != null) { blob += inputs.queries_gc_id_list.path + '\\n'; } \n  return blob; \n}"
                        },
                        {
                            "entryname": "t.mft",
                            "entry": "${\n  var blob = '# t.mft created for assm_assm_blastn_create_jobs from input \"subjects_gc_id_list\" File\\n'; \n  if(inputs.subjects_gc_id_list != null) { blob += inputs.subjects_gc_id_list.path + '\\n'; } \n  return blob; \n}"
                        }
                    ]
                }
            ],
            "arguments": [
                "-query-assemblies-manifest",
                "q.mft",
                "-target-assemblies-manifest",
                "t.mft"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-affinity-bin"
                    },
                    "id": "#assm_assm_blastn_create_jobs.cwl/affinity_bin"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#assm_assm_blastn_create_jobs.cwl/output_xml_file_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#assm_assm_blastn_create_jobs.cwl/queries_gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#assm_assm_blastn_create_jobs.cwl/subjects_gc_id_list"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_file_name)"
                    },
                    "id": "#assm_assm_blastn_create_jobs.cwl/output"
                }
            ],
            "id": "#assm_assm_blastn_create_jobs.cwl"
        },
        {
            "label": "assm_assm_blastn_wnode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "queries-and-targets.mft",
                            "entry": "${\n  var blob = '# queries-and-targets.mft created for assm_assm_blastn_wnode from input \"target_set\" File\\n'; \n  if(inputs.target_set != null) { \n    for(var i=0; i<inputs.target_set.length; i++) {\n      blob += inputs.target_set[i].path + '\\n'; \n    }\n  } \n  return blob; \n}"
                        }
                    ]
                }
            ],
            "baseCommand": "assm_assm_blastn_wnode",
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-compart"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/compart"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-evalue"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-gapextend"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/gapextend"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-gapopen"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/gapopen"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gc-cache"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/gc_cache"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/input_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-bases-per-call"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/max_bases_per_call"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max_target_seqs"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-merge-align-filter"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/merge_align_filter"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-merge-engine"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/merge_engine"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/output_dir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-soft_masking"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/soft_masking"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/target_set"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "queries-and-targets.mft",
                    "inputBinding": {
                        "prefix": "-target-set-manifest"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/target_set_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-task"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/task"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "-use-common-components"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/use_common_components"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-window_size"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/window_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-word_size"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/word_size"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-workers-per-cpu"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/workers_per_cpu"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)"
                    },
                    "id": "#assm_assm_blastn_wnode.cwl/outdir"
                }
            ],
            "id": "#assm_assm_blastn_wnode.cwl"
        },
        {
            "baseCommand": "cat",
            "class": "CommandLineTool",
            "doc": "concatenates input File[] to output File",
            "stdout": "$(inputs.output_file_name)",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cat.cwl/input"
                },
                {
                    "type": "string",
                    "default": "concatenated.file",
                    "id": "#cat.cwl/output_file_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#cat.cwl/output",
                    "outputBinding": {
                        "glob": "$(inputs.output_file_name)"
                    }
                }
            ],
            "id": "#cat.cwl"
        },
        {
            "label": "combine_kmer_sqlite.cwl",
            "doc": "Combine together reference kmer store and newly created kmer store for a new assembly",
            "class": "CommandLineTool",
            "baseCommand": "combine_kmer_sqlite",
            "inputs": [
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "-fast"
                    },
                    "id": "#combine_kmer_sqlite.cwl/fast"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "prefix": "-input-kmer-sqlite-uri",
                        "itemSeparator": ","
                    },
                    "id": "#combine_kmer_sqlite.cwl/kmer_cache_sqlite"
                },
                {
                    "type": "string",
                    "default": "combined_kmer_cache.sqlite",
                    "inputBinding": {
                        "prefix": "-output-kmer-sqlite-file"
                    },
                    "id": "#combine_kmer_sqlite.cwl/output_kmer_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_kmer_file)"
                    },
                    "id": "#combine_kmer_sqlite.cwl/combined_cache_sqlite"
                }
            ],
            "id": "#combine_kmer_sqlite.cwl"
        },
        {
            "label": "gc_extract_ids",
            "class": "CommandLineTool",
            "baseCommand": "gc_extract_ids",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#gc_extract_ids.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "gencoll.ids",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gc_extract_ids.cwl/output_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gc_extract_ids.cwl/output"
                }
            ],
            "id": "#gc_extract_ids.cwl"
        },
        {
            "label": "gc_get_assembly",
            "class": "CommandLineTool",
            "baseCommand": "gc_get_assembly",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gc-cache"
                    },
                    "id": "#gc_get_assembly.cwl/gc_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-mode"
                    },
                    "id": "#gc_get_assembly.cwl/mode"
                },
                {
                    "type": "string",
                    "default": "gencoll.asn",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gc_get_assembly.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-release_id_list"
                    },
                    "id": "#gc_get_assembly.cwl/release_id_list"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gc_get_assembly.cwl/gencoll_asn"
                }
            ],
            "id": "#gc_get_assembly.cwl"
        },
        {
            "label": "gpx_make_outputs",
            "class": "CommandLineTool",
            "baseCommand": "gpx_make_outputs",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_make_outputs.cwl/input_path"
                },
                {
                    "doc": "this parameter is fixed for this command line workflow, because the output is defined as single file\n",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "-num-partitions"
                    },
                    "id": "#gpx_make_outputs.cwl/num_partitions"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_make_outputs.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#gpx_make_outputs.cwl/output_glob"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "*",
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_make_outputs.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_glob)"
                    },
                    "id": "#gpx_make_outputs.cwl/output_file"
                }
            ],
            "id": "#gpx_make_outputs.cwl"
        },
        {
            "label": "gpx_qdump",
            "class": "CommandLineTool",
            "baseCommand": "gpx_qdump",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_qdump.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qdump.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-unzip"
                    },
                    "id": "#gpx_qdump.cwl/unzip"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gpx_qdump.cwl/output"
                }
            ],
            "id": "#gpx_qdump.cwl"
        },
        {
            "label": "gpx_qsubmit",
            "doc": "This workflow is specialized for the case when there is an XML input \n",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "${ var cs=0; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        },
                        {
                            "entry": "${ var cs=1; var s=inputs.asn_cache.length-1; var as = cs; if(as >= s) {as = s }; return inputs.asn_cache[as]; }",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "gpx_qsubmit",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-NxM-threshold"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/NxM_threshold"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "subject",
                    "inputBinding": {
                        "prefix": "-affinity"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/affinity"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "Directory"
                        }
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache",
                        "itemSeparator": ","
                    },
                    "id": "#gpx_qsubmit-xml.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-batch-size"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/batch_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-max-batch-length"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/max_batch_length"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": null,
                    "id": "#gpx_qsubmit-xml.cwl/nogenbank"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-o"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/output_xml_jobs"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-overlap"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/overlap"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-subseq-size"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/subseq_size"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xml-jobs"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/xml_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_xml_jobs)"
                    },
                    "id": "#gpx_qsubmit-xml.cwl/jobs"
                }
            ],
            "id": "#gpx_qsubmit-xml.cwl"
        },
        {
            "label": "kmer_build_tree",
            "class": "CommandLineTool",
            "baseCommand": "kmer_build_tree",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-distances"
                    },
                    "id": "#kmer_build_tree.cwl/distances"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "-no-merge"
                    },
                    "id": "#kmer_build_tree.cwl/no_merge"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-obin"
                    },
                    "id": "#kmer_build_tree.cwl/obin"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-otext"
                    },
                    "id": "#kmer_build_tree.cwl/otext"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "prefix": "-skip-markup"
                    },
                    "id": "#kmer_build_tree.cwl/skip_markup"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-sort"
                    },
                    "id": "#kmer_build_tree.cwl/sort"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.otext)"
                    },
                    "id": "#kmer_build_tree.cwl/tree"
                }
            ],
            "id": "#kmer_build_tree.cwl"
        },
        {
            "label": "kmer_compare_wnode",
            "class": "CommandLineTool",
            "baseCommand": "kmer_compare_wnode",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "submit_kmer_compare.kmer-files.mft",
                            "entry": "$(inputs.kmer_list.path)"
                        },
                        {
                            "entryname": "submit_kmer_compare.ref-kmer-files.mft",
                            "entry": "${var blob = '# submit_kmer_compare.ref-kmer-files.mft created for kmer_compare_wnode from input ref_kmer_list File\\n';  if(inputs.ref_kmer_list == null ) { return blob; } else { return blob +  inputs.ref_kmer_list.path + '\\n'; } }"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "outdir",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#kmer_compare_wnode.cwl/O"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-dist-method"
                    },
                    "id": "#kmer_compare_wnode.cwl/dist_method"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#kmer_compare_wnode.cwl/jobs"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-kmer-cache-uri"
                    },
                    "id": "#kmer_compare_wnode.cwl/kmer_cache_sqlite"
                },
                {
                    "type": "File",
                    "id": "#kmer_compare_wnode.cwl/kmer_list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "submit_kmer_compare.kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-kmer-files-manifest"
                    },
                    "id": "#kmer_compare_wnode.cwl/kmer_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "submit_kmer_compare.ref-kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-ref-kmer-files-manifest"
                    },
                    "id": "#kmer_compare_wnode.cwl/kmer_ref_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-minhash-signature"
                    },
                    "id": "#kmer_compare_wnode.cwl/minhash_signature"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#kmer_compare_wnode.cwl/ref_kmer_list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-score-method"
                    },
                    "id": "#kmer_compare_wnode.cwl/score_method"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.O)"
                    },
                    "id": "#kmer_compare_wnode.cwl/outdir"
                }
            ],
            "id": "#kmer_compare_wnode.cwl"
        },
        {
            "label": "kmer_extract_wnode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.input)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "kmer_extract_wnode",
            "arguments": [
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "Directory"
                    ],
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#kmer_extract_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "-backlog"
                    },
                    "id": "#kmer_extract_wnode.cwl/backlog"
                },
                {
                    "doc": "Used only to be preserved",
                    "type": "File",
                    "id": "#kmer_extract_wnode.cwl/input"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#kmer_extract_wnode.cwl/input_jobs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-type"
                    },
                    "id": "#kmer_extract_wnode.cwl/input_type"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 18,
                    "inputBinding": {
                        "prefix": "-k"
                    },
                    "id": "#kmer_extract_wnode.cwl/k"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#kmer_extract_wnode.cwl/kmer_output_dir"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 1,
                    "inputBinding": {
                        "prefix": "-max-jobs"
                    },
                    "id": "#kmer_extract_wnode.cwl/max_jobs"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.kmer_output_dir)"
                    },
                    "id": "#kmer_extract_wnode.cwl/outdir"
                }
            ],
            "id": "#kmer_extract_wnode.cwl"
        },
        {
            "label": "kmer_files2sqlite.cwl",
            "doc": "Convert input .kmer.gz (kmer_file) and .xml (kmer_metadata_file)\ninto new sqlite database\nTakes a directory input\n",
            "class": "CommandLineTool",
            "baseCommand": "kmer_files2sqlite",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.kmer_dir)",
                            "writable": false
                        },
                        {
                            "entryname": "keys.ids",
                            "entry": "${ var blob = ''; for (var i = 0; i < inputs.kmer_dir.listing.length; i++) { var nameext = inputs.kmer_dir.listing[i].nameext; if ( nameext == \".gz\" ) { blob += inputs.kmer_dir.listing[i].path + '\\n'; } } return blob; }",
                            "writable": false
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "keys.ids",
                    "inputBinding": {
                        "prefix": "-gencoll-ids"
                    },
                    "id": "#kmer_files2sqlite.cwl/keys"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-file-uri"
                    },
                    "id": "#kmer_files2sqlite.cwl/kmer_dir"
                },
                {
                    "type": "string",
                    "default": "local_kmer_cache.sqlite",
                    "inputBinding": {
                        "prefix": "-db-uri"
                    },
                    "id": "#kmer_files2sqlite.cwl/output_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_file)"
                    },
                    "id": "#kmer_files2sqlite.cwl/out_kmer_cache_sqlite"
                }
            ],
            "id": "#kmer_files2sqlite.cwl"
        },
        {
            "label": "kmer_top_identification",
            "class": "CommandLineTool",
            "baseCommand": "kmer_top_identification",
            "inputs": [
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "prefix": "-N"
                    },
                    "id": "#kmer_top_identification.cwl/N"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-distances"
                    },
                    "id": "#kmer_top_identification.cwl/distances"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-kmer-cache-uri"
                    },
                    "id": "#kmer_top_identification.cwl/kmer_cache_sqlite"
                },
                {
                    "type": "string",
                    "default": "matches.txt",
                    "inputBinding": {
                        "prefix": "-omatches"
                    },
                    "id": "#kmer_top_identification.cwl/omatches"
                },
                {
                    "type": "string",
                    "default": "top_distances.xml",
                    "inputBinding": {
                        "prefix": "-oxml"
                    },
                    "id": "#kmer_top_identification.cwl/oxml"
                },
                {
                    "type": "float",
                    "inputBinding": {
                        "prefix": "-threshold"
                    },
                    "id": "#kmer_top_identification.cwl/threshold"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.omatches)"
                    },
                    "id": "#kmer_top_identification.cwl/matches"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.oxml)"
                    },
                    "id": "#kmer_top_identification.cwl/top_distances"
                }
            ],
            "id": "#kmer_top_identification.cwl"
        },
        {
            "label": "kmer_top_n_extract",
            "class": "CommandLineTool",
            "baseCommand": "kmer_top_n_extract",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gcextract2-sqlite"
                    },
                    "id": "#kmer_top_n_extract.cwl/gcextract2_sqlite"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#kmer_top_n_extract.cwl/input"
                },
                {
                    "type": "string",
                    "default": "top-reference-assms",
                    "inputBinding": {
                        "prefix": "-otop-assms"
                    },
                    "id": "#kmer_top_n_extract.cwl/otop_assms"
                },
                {
                    "type": "string",
                    "default": "kmer-tax-report.xml",
                    "inputBinding": {
                        "prefix": "-otop-assms-xml"
                    },
                    "id": "#kmer_top_n_extract.cwl/otop_assms_xml"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-ref-assembly-id"
                    },
                    "id": "#kmer_top_n_extract.cwl/ref_assembly_id"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-ref-assembly-taxid"
                    },
                    "id": "#kmer_top_n_extract.cwl/ref_assembly_taxid"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-taxon-db"
                    },
                    "id": "#kmer_top_n_extract.cwl/taxon_db"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "inputBinding": {
                        "prefix": "-threshold"
                    },
                    "id": "#kmer_top_n_extract.cwl/threshold"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.otop_assms)"
                    },
                    "id": "#kmer_top_n_extract.cwl/gc_id_list"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.otop_assms_xml)"
                    },
                    "id": "#kmer_top_n_extract.cwl/tax_report"
                }
            ],
            "id": "#kmer_top_n_extract.cwl"
        },
        {
            "doc": "Produces the list of all keys in sqlite database",
            "label": "list_kmer_sqlite.cwl",
            "baseCommand": "list_kmer_sqlite",
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-kmer-cache-uri"
                    },
                    "id": "#list_kmer_sqlite.cwl/kmer_cache_sqlite"
                },
                {
                    "type": "string",
                    "default": "sqlite-listing.ids",
                    "inputBinding": {
                        "prefix": "-listing"
                    },
                    "id": "#list_kmer_sqlite.cwl/out_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.out_name)"
                    },
                    "id": "#list_kmer_sqlite.cwl/keys"
                }
            ],
            "id": "#list_kmer_sqlite.cwl"
        },
        {
            "label": "submit_kmer_compare",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "submit_kmer_compare.kmer-files.mft",
                            "entry": "${return '# submit_kmer_compare.kmer-files.mft created for submit_kmer_compare from input kmer_list File\\n' + inputs.kmer_list.path + '\\n'; }"
                        },
                        {
                            "entryname": "submit_kmer_compare.ref-kmer-files.mft",
                            "entry": "${var blob =  '# submit_kmer_compare.ref-kmer-files.mft created for submit_kmer_compare from input ref_kmer_list File\\n'; if ( inputs.ref_kmer_list == null) { return blob; } else { return blob + inputs.ref_kmer_list.path + '\\n'; }}"
                        }
                    ]
                }
            ],
            "baseCommand": "submit_kmer_compare",
            "inputs": [
                {
                    "type": "File",
                    "id": "#submit_kmer_compare.cwl/kmer_list"
                },
                {
                    "type": "string",
                    "default": "submit_kmer_compare.kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-kmer-files-manifest"
                    },
                    "id": "#submit_kmer_compare.cwl/kmer_list_impl"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#submit_kmer_compare.cwl/o"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#submit_kmer_compare.cwl/ref_kmer_list"
                },
                {
                    "type": "string",
                    "default": "submit_kmer_compare.ref-kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-ref-kmer-files-manifest"
                    },
                    "id": "#submit_kmer_compare.cwl/ref_kmer_list_impl"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    },
                    "id": "#submit_kmer_compare.cwl/output"
                }
            ],
            "id": "#submit_kmer_compare.cwl"
        },
        {
            "label": "submit_kmer_compare",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "submit_kmer_compare.kmer-files.mft",
                            "entry": "${return '# submit_kmer_compare.kmer-files.mft created for submit_kmer_compare from input kmer_list File\\n' + inputs.kmer_list.path + '\\n'; }"
                        }
                    ]
                }
            ],
            "baseCommand": "submit_kmer_compare",
            "inputs": [
                {
                    "type": "File",
                    "id": "#submit_kmer_compare_tmp_pairwise.cwl/kmer_list"
                },
                {
                    "type": "string",
                    "default": "submit_kmer_compare.kmer-files.mft",
                    "inputBinding": {
                        "prefix": "-kmer-files-manifest"
                    },
                    "id": "#submit_kmer_compare_tmp_pairwise.cwl/kmer_list_impl"
                },
                {
                    "type": "string",
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#submit_kmer_compare_tmp_pairwise.cwl/o"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.o)"
                    },
                    "id": "#submit_kmer_compare_tmp_pairwise.cwl/output"
                }
            ],
            "id": "#submit_kmer_compare_tmp_pairwise.cwl"
        },
        {
            "label": "submit_kmer_extract",
            "doc": "We need $(inputs.seq_entry) to be a local file to the current subdirectory since the file name goes to output.xml, a notorious file with files.\n",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.seq_entry)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "submit_kmer_extract",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "expected_kmer_files",
                    "inputBinding": {
                        "prefix": "-expected-output"
                    },
                    "id": "#submit_kmer_extract.cwl/expected_output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-gc-id-list"
                    },
                    "id": "#submit_kmer_extract.cwl/gc_id_list"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-kmer-output-dir"
                    },
                    "id": "#submit_kmer_extract.cwl/kmer_output_dir"
                },
                {
                    "type": "string",
                    "default": "output.xml",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#submit_kmer_extract.cwl/output"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-seq-entry"
                    },
                    "id": "#submit_kmer_extract.cwl/seq_entry"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#submit_kmer_extract.cwl/jobs"
                }
            ],
            "id": "#submit_kmer_extract.cwl"
        },
        {
            "label": "xml_evaluate",
            "class": "CommandLineTool",
            "baseCommand": "xml_evaluate",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "stdout": "$(inputs.stdout_redir)",
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-conffile"
                    },
                    "id": "#xml_evaluate.cwl/conffile"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-ignore-all-errors"
                    },
                    "id": "#xml_evaluate.cwl/ignore_all_errors"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#xml_evaluate.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-input-manifest"
                    },
                    "id": "#xml_evaluate.cwl/input_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-input-mask"
                    },
                    "id": "#xml_evaluate.cwl/input_mask"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#xml_evaluate.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-logfile"
                    },
                    "id": "#xml_evaluate.cwl/logfile_output"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "stdout",
                    "id": "#xml_evaluate.cwl/stdout_redir"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-xml-output"
                    },
                    "id": "#xml_evaluate.cwl/xml_output_output"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-xpath-fail"
                    },
                    "id": "#xml_evaluate.cwl/xpath_fail"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-xpath-success"
                    },
                    "id": "#xml_evaluate.cwl/xpath_success"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xslt"
                    },
                    "id": "#xml_evaluate.cwl/xslt"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-xslt-manifest"
                    },
                    "id": "#xml_evaluate.cwl/xslt_manifest"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-xslt-mask"
                    },
                    "id": "#xml_evaluate.cwl/xslt_mask"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-xslt-path"
                    },
                    "id": "#xml_evaluate.cwl/xslt_path"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.logfile_output)"
                    },
                    "id": "#xml_evaluate.cwl/logfile"
                },
                {
                    "type": "boolean",
                    "outputBinding": {
                        "outputEval": "$(true)"
                    },
                    "id": "#xml_evaluate.cwl/success"
                },
                {
                    "type": "File",
                    "id": "#xml_evaluate.cwl/xml_output",
                    "outputBinding": {
                        "glob": "$(inputs.stdout_redir)"
                    }
                }
            ],
            "id": "#xml_evaluate.cwl"
        },
        {
            "label": "xsltproc",
            "class": "CommandLineTool",
            "baseCommand": "xsltproc",
            "inputs": [
                {
                    "type": "string",
                    "default": "var_proc_annot_stats.val.xml",
                    "inputBinding": {
                        "prefix": "--output"
                    },
                    "id": "#xsltproc.cwl/output_name"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#xsltproc.cwl/xml"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#xsltproc.cwl/xslt"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#xsltproc.cwl/output"
                }
            ],
            "id": "#xsltproc.cwl"
        },
        {
            "label": "ani_top_n",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#tt_ani_top_n.cwl/ANI_cutoff"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "Directory"
                    },
                    "id": "#tt_ani_top_n.cwl/asn_cache"
                },
                {
                    "type": "File",
                    "id": "#tt_ani_top_n.cwl/blast_align"
                },
                {
                    "type": "File",
                    "id": "#tt_ani_top_n.cwl/gcextract2_sqlite"
                },
                {
                    "type": "File",
                    "id": "#tt_ani_top_n.cwl/gencoll_asn"
                },
                {
                    "type": "int",
                    "id": "#tt_ani_top_n.cwl/ref_assembly_id"
                },
                {
                    "type": "int",
                    "id": "#tt_ani_top_n.cwl/ref_assembly_taxid"
                },
                {
                    "type": "File",
                    "id": "#tt_ani_top_n.cwl/ref_gencoll_asn"
                },
                {
                    "type": "File",
                    "id": "#tt_ani_top_n.cwl/tax_synon"
                },
                {
                    "type": "File",
                    "id": "#tt_ani_top_n.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_ani_top_n.cwl/ani_top_identification/annot",
                    "id": "#tt_ani_top_n.cwl/annot"
                },
                {
                    "type": "File",
                    "outputSource": "#tt_ani_top_n.cwl/ani_top_identification/top",
                    "id": "#tt_ani_top_n.cwl/top"
                }
            ],
            "steps": [
                {
                    "run": "#ani_top_identification.cwl",
                    "in": [
                        {
                            "source": "#tt_ani_top_n.cwl/ANI_cutoff",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/ANI_cutoff"
                        },
                        {
                            "default": 25,
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/N"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/asn_cache",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/asn_cache"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/gcextract2_sqlite",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/gcextract2_sqlite"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/blast_align",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/input"
                        },
                        {
                            "default": 10000,
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/min_gap"
                        },
                        {
                            "default": 100,
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/min_region"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/gencoll_asn",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/query_assembly"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/ref_gencoll_asn",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/ref_assemblies"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/ref_assembly_id",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/ref_assembly_id"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/ref_assembly_taxid",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/ref_assembly_taxid"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/tax_synon",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/tax_synon"
                        },
                        {
                            "source": "#tt_ani_top_n.cwl/taxon_db",
                            "id": "#tt_ani_top_n.cwl/ani_top_identification/taxon_db"
                        }
                    ],
                    "out": [
                        "#tt_ani_top_n.cwl/ani_top_identification/annot",
                        "#tt_ani_top_n.cwl/ani_top_identification/top"
                    ],
                    "id": "#tt_ani_top_n.cwl/ani_top_identification"
                }
            ],
            "id": "#tt_ani_top_n.cwl"
        },
        {
            "label": "assm_assm_blastn_wnode",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "string",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/affinity"
                },
                {
                    "type": "Directory",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/compart"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/evalue"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/gapextend"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/gapopen"
                },
                {
                    "type": "File",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/gc_cache"
                },
                {
                    "type": "Directory",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/gc_seq_cache"
                },
                {
                    "type": "File",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/gencoll_asn"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/max_bases_per_call"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/max_target_seqs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/merge_align_filter"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/merge_engine"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/nogenbank"
                },
                {
                    "type": "File",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/queries_gc_id_list"
                },
                {
                    "type": "File",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/ref_gencoll_asn"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/soft_masking"
                },
                {
                    "type": "File",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/subjects_gc_id_list"
                },
                {
                    "type": "string",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/task"
                },
                {
                    "type": "boolean",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/use_common_components"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/window_size"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/word_size"
                },
                {
                    "type": [
                        "null",
                        "float"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/workers_per_cpu"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_assm_assm_blastn_wnode.cwl/gpx_qdump/output",
                    "id": "#tt_assm_assm_blastn_wnode.cwl/blast_align"
                }
            ],
            "steps": [
                {
                    "run": "#assm_assm_blastn_create_jobs.cwl",
                    "in": [
                        {
                            "default": 10,
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_create_jobs/affinity_bin"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/queries_gc_id_list",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_create_jobs/queries_gc_id_list"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/subjects_gc_id_list",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_create_jobs/subjects_gc_id_list"
                        }
                    ],
                    "out": [
                        "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_create_jobs/output"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_create_jobs"
                },
                {
                    "run": "#assm_assm_blastn_wnode.cwl",
                    "in": [
                        {
                            "source": [
                                "#tt_assm_assm_blastn_wnode.cwl/asn_cache",
                                "#tt_assm_assm_blastn_wnode.cwl/gc_seq_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/asn_cache"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/compart",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/compart"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/evalue",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/evalue"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/gapextend",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/gapextend"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/gapopen",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/gapopen"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/gc_cache",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/gc_cache"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/gpx_qsubmit/jobs",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/input_jobs"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/max_bases_per_call",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/max_bases_per_call"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/max_target_seqs",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/max_target_seqs"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/merge_align_filter",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/merge_align_filter"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/merge_engine",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/merge_engine"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/soft_masking",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/soft_masking"
                        },
                        {
                            "source": [
                                "#tt_assm_assm_blastn_wnode.cwl/gencoll_asn",
                                "#tt_assm_assm_blastn_wnode.cwl/ref_gencoll_asn"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/target_set"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/task",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/task"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/use_common_components",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/use_common_components"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/window_size",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/window_size"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/word_size",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/word_size"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/workers_per_cpu",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/workers_per_cpu"
                        }
                    ],
                    "out": [
                        "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/outdir"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode"
                },
                {
                    "run": "#gpx_qdump.cwl",
                    "in": [
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_wnode/outdir",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/gpx_qdump/input_path"
                        },
                        {
                            "default": "*",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/gpx_qdump/unzip"
                        }
                    ],
                    "out": [
                        "#tt_assm_assm_blastn_wnode.cwl/gpx_qdump/output"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/gpx_qdump"
                },
                {
                    "run": "#gpx_qsubmit-xml.cwl",
                    "in": [
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/affinity",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/gpx_qsubmit/affinity"
                        },
                        {
                            "source": [
                                "#tt_assm_assm_blastn_wnode.cwl/asn_cache"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/gpx_qsubmit/asn_cache"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/nogenbank",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/gpx_qsubmit/nogenbank"
                        },
                        {
                            "source": "#tt_assm_assm_blastn_wnode.cwl/assm_assm_blastn_create_jobs/output",
                            "id": "#tt_assm_assm_blastn_wnode.cwl/gpx_qsubmit/xml_jobs"
                        }
                    ],
                    "out": [
                        "#tt_assm_assm_blastn_wnode.cwl/gpx_qsubmit/jobs"
                    ],
                    "id": "#tt_assm_assm_blastn_wnode.cwl/gpx_qsubmit"
                }
            ],
            "id": "#tt_assm_assm_blastn_wnode.cwl"
        },
        {
            "label": "gcaccess_from_list",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#tt_gcaccess_from_list.cwl/gc_cache"
                },
                {
                    "type": "File",
                    "id": "#tt_gcaccess_from_list.cwl/gc_id_list"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_gcaccess_from_list.cwl/gc_get_assembly/gencoll_asn",
                    "id": "#tt_gcaccess_from_list.cwl/gencoll_asn"
                }
            ],
            "steps": [
                {
                    "run": "#gc_get_assembly.cwl",
                    "in": [
                        {
                            "source": "#tt_gcaccess_from_list.cwl/gc_cache",
                            "id": "#tt_gcaccess_from_list.cwl/gc_get_assembly/gc_cache"
                        },
                        {
                            "default": "AllSequences",
                            "id": "#tt_gcaccess_from_list.cwl/gc_get_assembly/mode"
                        },
                        {
                            "source": "#tt_gcaccess_from_list.cwl/gc_id_list",
                            "id": "#tt_gcaccess_from_list.cwl/gc_get_assembly/release_id_list"
                        }
                    ],
                    "out": [
                        "#tt_gcaccess_from_list.cwl/gc_get_assembly/gencoll_asn"
                    ],
                    "id": "#tt_gcaccess_from_list.cwl/gc_get_assembly"
                }
            ],
            "id": "#tt_gcaccess_from_list.cwl"
        },
        {
            "label": "kmer_build_tree",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#tt_kmer_build_tree.cwl/distances"
                },
                {
                    "type": "boolean",
                    "id": "#tt_kmer_build_tree.cwl/no_merge"
                },
                {
                    "type": "boolean",
                    "id": "#tt_kmer_build_tree.cwl/skip_markup"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#tt_kmer_build_tree.cwl/sort"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#tt_kmer_build_tree.cwl/tree"
                }
            ],
            "steps": [
                {
                    "run": "#kmer_build_tree.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_build_tree.cwl/distances",
                            "id": "#tt_kmer_build_tree.cwl/kmer_build_tree/distances"
                        },
                        {
                            "source": "#tt_kmer_build_tree.cwl/no_merge",
                            "id": "#tt_kmer_build_tree.cwl/kmer_build_tree/no_merge"
                        },
                        {
                            "default": "tree_bin.asn",
                            "id": "#tt_kmer_build_tree.cwl/kmer_build_tree/obin"
                        },
                        {
                            "default": "tree_text.asn",
                            "id": "#tt_kmer_build_tree.cwl/kmer_build_tree/otext"
                        },
                        {
                            "source": "#tt_kmer_build_tree.cwl/skip_markup",
                            "id": "#tt_kmer_build_tree.cwl/kmer_build_tree/skip_markup"
                        },
                        {
                            "source": "#tt_kmer_build_tree.cwl/sort",
                            "id": "#tt_kmer_build_tree.cwl/kmer_build_tree/sort"
                        }
                    ],
                    "out": [
                        "#tt_kmer_build_tree.cwl/kmer_build_tree/tree"
                    ],
                    "id": "#tt_kmer_build_tree.cwl/kmer_build_tree"
                }
            ],
            "id": "#tt_kmer_build_tree.cwl"
        },
        {
            "label": "tt_kmer_compare_wnode",
            "doc": "Pairwise comparison",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "string",
                    "id": "#tt_kmer_compare_wnode.cwl/dist_method"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_compare_wnode.cwl/kmer_cache_sqlite"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_compare_wnode.cwl/kmer_list"
                },
                {
                    "type": "string",
                    "id": "#tt_kmer_compare_wnode.cwl/minhash_signature"
                },
                {
                    "type": "string",
                    "id": "#tt_kmer_compare_wnode.cwl/score_method"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_kmer_compare_wnode.cwl/gpx_make_outputs/output_file",
                    "id": "#tt_kmer_compare_wnode.cwl/distances"
                }
            ],
            "steps": [
                {
                    "run": "#gpx_make_outputs.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode/outdir",
                            "id": "#tt_kmer_compare_wnode.cwl/gpx_make_outputs/input_path"
                        },
                        {
                            "default": 1,
                            "id": "#tt_kmer_compare_wnode.cwl/gpx_make_outputs/num_partitions"
                        },
                        {
                            "default": "distances.##.gz",
                            "id": "#tt_kmer_compare_wnode.cwl/gpx_make_outputs/output"
                        },
                        {
                            "default": "distances.*.gz",
                            "id": "#tt_kmer_compare_wnode.cwl/gpx_make_outputs/output_glob"
                        },
                        {
                            "default": "dont-unzip",
                            "id": "#tt_kmer_compare_wnode.cwl/gpx_make_outputs/unzip"
                        }
                    ],
                    "out": [
                        "#tt_kmer_compare_wnode.cwl/gpx_make_outputs/output_file"
                    ],
                    "id": "#tt_kmer_compare_wnode.cwl/gpx_make_outputs"
                },
                {
                    "run": "#kmer_compare_wnode.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_compare_wnode.cwl/dist_method",
                            "id": "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode/dist_method"
                        },
                        {
                            "source": "#tt_kmer_compare_wnode.cwl/submit_kmer_compare/output",
                            "id": "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode/jobs"
                        },
                        {
                            "source": "#tt_kmer_compare_wnode.cwl/kmer_cache_sqlite",
                            "id": "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode/kmer_cache_sqlite"
                        },
                        {
                            "source": "#tt_kmer_compare_wnode.cwl/kmer_list",
                            "id": "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode/kmer_list"
                        },
                        {
                            "source": "#tt_kmer_compare_wnode.cwl/minhash_signature",
                            "id": "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode/minhash_signature"
                        },
                        {
                            "source": "#tt_kmer_compare_wnode.cwl/score_method",
                            "id": "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode/score_method"
                        }
                    ],
                    "out": [
                        "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode/outdir"
                    ],
                    "id": "#tt_kmer_compare_wnode.cwl/kmer_compare_wnode"
                },
                {
                    "run": "#submit_kmer_compare_tmp_pairwise.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_compare_wnode.cwl/kmer_list",
                            "id": "#tt_kmer_compare_wnode.cwl/submit_kmer_compare/kmer_list"
                        }
                    ],
                    "out": [
                        "#tt_kmer_compare_wnode.cwl/submit_kmer_compare/output"
                    ],
                    "id": "#tt_kmer_compare_wnode.cwl/submit_kmer_compare"
                }
            ],
            "id": "#tt_kmer_compare_wnode.cwl"
        },
        {
            "label": "kmer_ref_compare_wnode",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "string",
                    "id": "#tt_kmer_ref_compare_wnode.cwl/dist_method"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_cache_sqlite"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_list"
                },
                {
                    "type": "string",
                    "id": "#tt_kmer_ref_compare_wnode.cwl/minhash_signature"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_ref_compare_wnode.cwl/ref_kmer_list"
                },
                {
                    "type": "string",
                    "id": "#tt_kmer_ref_compare_wnode.cwl/score_method"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_kmer_ref_compare_wnode.cwl/gpx_make_outputs/output_file",
                    "id": "#tt_kmer_ref_compare_wnode.cwl/distances"
                },
                {
                    "doc": "we hope to use this to pass instead of file list",
                    "type": "Directory",
                    "outputSource": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/outdir",
                    "id": "#tt_kmer_ref_compare_wnode.cwl/outdir"
                }
            ],
            "steps": [
                {
                    "run": "#gpx_make_outputs.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/outdir",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/gpx_make_outputs/input_path"
                        },
                        {
                            "default": 1,
                            "id": "#tt_kmer_ref_compare_wnode.cwl/gpx_make_outputs/num_partitions"
                        },
                        {
                            "default": "distances.##.gz",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/gpx_make_outputs/output"
                        },
                        {
                            "default": "distances.*.gz",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/gpx_make_outputs/output_glob"
                        },
                        {
                            "default": "dont-unzip",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/gpx_make_outputs/unzip"
                        }
                    ],
                    "out": [
                        "#tt_kmer_ref_compare_wnode.cwl/gpx_make_outputs/output_file"
                    ],
                    "id": "#tt_kmer_ref_compare_wnode.cwl/gpx_make_outputs"
                },
                {
                    "run": "#kmer_compare_wnode.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/dist_method",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/dist_method"
                        },
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/submit_kmer_compare/output",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/jobs"
                        },
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/kmer_cache_sqlite",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/kmer_cache_sqlite"
                        },
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/kmer_list",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/kmer_list"
                        },
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/minhash_signature",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/minhash_signature"
                        },
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/ref_kmer_list",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/ref_kmer_list"
                        },
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/score_method",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/score_method"
                        }
                    ],
                    "out": [
                        "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode/outdir"
                    ],
                    "id": "#tt_kmer_ref_compare_wnode.cwl/kmer_compare_wnode"
                },
                {
                    "run": "#submit_kmer_compare.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/kmer_list",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/submit_kmer_compare/kmer_list"
                        },
                        {
                            "source": "#tt_kmer_ref_compare_wnode.cwl/ref_kmer_list",
                            "id": "#tt_kmer_ref_compare_wnode.cwl/submit_kmer_compare/ref_kmer_list"
                        }
                    ],
                    "out": [
                        "#tt_kmer_ref_compare_wnode.cwl/submit_kmer_compare/output"
                    ],
                    "id": "#tt_kmer_ref_compare_wnode.cwl/submit_kmer_compare"
                }
            ],
            "id": "#tt_kmer_ref_compare_wnode.cwl"
        },
        {
            "label": "kmer_seq_entry_extract_wnode",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#tt_kmer_seq_entry_extract_wnode.cwl/asn_cache"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_seq_entry_extract_wnode.cwl/entry"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_file_list"
                },
                {
                    "type": "string",
                    "default": "kmer_dir",
                    "id": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_output_dir"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputSource": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_extract_wnode/outdir",
                    "id": "#tt_kmer_seq_entry_extract_wnode.cwl/out_kmer_dir"
                }
            ],
            "steps": [
                {
                    "run": "#kmer_extract_wnode.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_seq_entry_extract_wnode.cwl/asn_cache",
                            "id": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_extract_wnode/asn_cache"
                        },
                        {
                            "source": "#tt_kmer_seq_entry_extract_wnode.cwl/entry",
                            "id": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_extract_wnode/input"
                        },
                        {
                            "source": "#tt_kmer_seq_entry_extract_wnode.cwl/submit_kmer_extract/jobs",
                            "id": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_extract_wnode/input_jobs"
                        },
                        {
                            "default": "seq-entry",
                            "id": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_extract_wnode/input_type"
                        },
                        {
                            "source": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_output_dir",
                            "id": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_extract_wnode/kmer_output_dir"
                        }
                    ],
                    "out": [
                        "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_extract_wnode/outdir"
                    ],
                    "id": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_extract_wnode"
                },
                {
                    "run": "#submit_kmer_extract.cwl",
                    "in": [
                        {
                            "default": "expected_kmer_files",
                            "id": "#tt_kmer_seq_entry_extract_wnode.cwl/submit_kmer_extract/expected_output"
                        },
                        {
                            "source": "#tt_kmer_seq_entry_extract_wnode.cwl/kmer_output_dir",
                            "id": "#tt_kmer_seq_entry_extract_wnode.cwl/submit_kmer_extract/kmer_output_dir"
                        },
                        {
                            "source": "#tt_kmer_seq_entry_extract_wnode.cwl/entry",
                            "id": "#tt_kmer_seq_entry_extract_wnode.cwl/submit_kmer_extract/seq_entry"
                        }
                    ],
                    "out": [
                        "#tt_kmer_seq_entry_extract_wnode.cwl/submit_kmer_extract/jobs"
                    ],
                    "id": "#tt_kmer_seq_entry_extract_wnode.cwl/submit_kmer_extract"
                }
            ],
            "id": "#tt_kmer_seq_entry_extract_wnode.cwl"
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#tt_kmer_top_n.cwl/distances"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_top_n.cwl/kmer_cache_sqlite"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_kmer_top_n.cwl/kmer_top_identification/matches",
                    "id": "#tt_kmer_top_n.cwl/matches"
                },
                {
                    "type": "File",
                    "outputSource": "#tt_kmer_top_n.cwl/kmer_top_identification/top_distances",
                    "id": "#tt_kmer_top_n.cwl/top_distances"
                }
            ],
            "steps": [
                {
                    "run": "#kmer_top_identification.cwl",
                    "in": [
                        {
                            "default": 20,
                            "id": "#tt_kmer_top_n.cwl/kmer_top_identification/N"
                        },
                        {
                            "source": "#tt_kmer_top_n.cwl/distances",
                            "id": "#tt_kmer_top_n.cwl/kmer_top_identification/distances"
                        },
                        {
                            "source": "#tt_kmer_top_n.cwl/kmer_cache_sqlite",
                            "id": "#tt_kmer_top_n.cwl/kmer_top_identification/kmer_cache_sqlite"
                        },
                        {
                            "default": 0.8,
                            "id": "#tt_kmer_top_n.cwl/kmer_top_identification/threshold"
                        }
                    ],
                    "out": [
                        "#tt_kmer_top_n.cwl/kmer_top_identification/top_distances",
                        "#tt_kmer_top_n.cwl/kmer_top_identification/matches"
                    ],
                    "id": "#tt_kmer_top_n.cwl/kmer_top_identification"
                }
            ],
            "id": "#tt_kmer_top_n.cwl"
        },
        {
            "label": "kmer_top_n_extract",
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#tt_kmer_top_n_extract.cwl/gcextract2_sqlite"
                },
                {
                    "type": "int",
                    "id": "#tt_kmer_top_n_extract.cwl/ref_assembly_id"
                },
                {
                    "type": "int",
                    "id": "#tt_kmer_top_n_extract.cwl/ref_assembly_taxid"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_top_n_extract.cwl/taxon_db"
                },
                {
                    "type": "File",
                    "id": "#tt_kmer_top_n_extract.cwl/top_distances"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/gc_id_list",
                    "id": "#tt_kmer_top_n_extract.cwl/gc_id_list"
                },
                {
                    "type": "File",
                    "outputSource": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/tax_report",
                    "id": "#tt_kmer_top_n_extract.cwl/tax_report"
                }
            ],
            "steps": [
                {
                    "run": "#kmer_top_n_extract.cwl",
                    "in": [
                        {
                            "source": "#tt_kmer_top_n_extract.cwl/gcextract2_sqlite",
                            "id": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/gcextract2_sqlite"
                        },
                        {
                            "source": "#tt_kmer_top_n_extract.cwl/top_distances",
                            "id": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/input"
                        },
                        {
                            "source": "#tt_kmer_top_n_extract.cwl/ref_assembly_id",
                            "id": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/ref_assembly_id"
                        },
                        {
                            "source": "#tt_kmer_top_n_extract.cwl/ref_assembly_taxid",
                            "id": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/ref_assembly_taxid"
                        },
                        {
                            "source": "#tt_kmer_top_n_extract.cwl/taxon_db",
                            "id": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/taxon_db"
                        },
                        {
                            "default": 0.1,
                            "id": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/threshold"
                        }
                    ],
                    "out": [
                        "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/tax_report",
                        "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract/gc_id_list"
                    ],
                    "id": "#tt_kmer_top_n_extract.cwl/kmer_top_n_extract"
                }
            ],
            "id": "#tt_kmer_top_n_extract.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
